import type Swup from '../Swup.js';
import type { Options } from '../Swup.js';
declare const TRANSITION = "transition";
declare const ANIMATION = "animation";
type AnimationTypes = typeof TRANSITION | typeof ANIMATION;
export type AnimationDirection = 'in' | 'out';
/**
 * Return a Promise that resolves when all CSS animations and transitions
 * are done on the page. Filters by selector or takes elements directly.
 */
export declare function awaitAnimations(this: Swup, { elements, selector }: {
    selector: Options['animationSelector'];
    elements?: NodeListOf<HTMLElement> | HTMLElement[];
}): Promise<void>;
export declare function getTransitionInfo(element: Element, expectedType?: AnimationTypes): {
    type: AnimationTypes | null;
    timeout: number;
    propCount: number;
};
export {};
//# sourceMappingURL=awaitAnimations.d.ts.map