/** Find an element by selector. */
export declare const query: (selector: string, context?: Document | Element) => HTMLElement | null;
/** Find a set of elements by selector. */
export declare const queryAll: (selector: string, context?: Document | Element) => HTMLElement[];
/** Return a Promise that resolves after the next event loop. */
export declare const nextTick: () => Promise<void>;
/** Check if an object is a Promise or a Thenable */
export declare function isPromise<T>(obj: unknown): obj is PromiseLike<T>;
/** Call a function as a Promise. Resolves with the returned Promsise or immediately. */
export declare function runAsPromise(func: Function, args?: unknown[]): Promise<unknown>;
/**
 * Force a layout reflow, e.g. after adding classnames
 * @returns The offset height, just here so it doesn't get optimized away by the JS engine
 * @see https://stackoverflow.com/a/21665117/3759615
 */
export declare function forceReflow(element?: HTMLElement): number;
/** Escape a string with special chars to not break CSS selectors. */
export declare const escapeCssIdentifier: (ident: string) => string;
/** Fix for Chrome below v61 formatting CSS floats with comma in some locales. */
export declare const toMs: (s: string) => number;
//# sourceMappingURL=index.d.ts.map